export type DownloadRequest = DownloadByFileId | DownloadByFilePath | DownloadByFileUrl;

export interface DownloadRequestBase {
  /**
   * Local file path.
   */
  destinationFile: string;
}

export interface DownloadByFileId extends DownloadRequestBase {
  /**
   * File ID for a file in the 'uploads' folder.
   */
  sourceFileId: string;

  /**
   * Path to a file managed by Upload.io, relative to the current file.
   */
  sourceFilePath?: undefined;

  /**
   * URL to a file on the Internet.
   */
  sourceFileUrl?: undefined;
}

export interface DownloadByFilePath extends DownloadRequestBase {
  /**
   * File ID for a file in the 'uploads' folder.
   */
  sourceFileId?: undefined;

  /**
   * Path to a file managed by Upload.io, relative to the current file.
   */
  sourceFilePath: string;

  /**
   * URL to a file on the Internet.
   */
  sourceFileUrl?: undefined;
}

export interface DownloadByFileUrl extends DownloadRequestBase {
  /**
   * File ID for a file in the 'uploads' folder.
   */
  sourceFileId?: undefined;

  /**
   * Path to a file managed by Upload.io, relative to the current file.
   */
  sourceFilePath?: undefined;

  /**
   * URL to a file on the Internet.
   */
  sourceFileUrl: string;
}
