import { FileMetadata } from "upload-plugin-sdk";

/**
 * Gets the metadata for a file.
 *
 * A 'URL path' is the relative path where a file is stored on the Upload CDN.
 *
 * For example, the URL path '/foo' corresponds to the URL 'https://cdn.upload.io/<fileId>/<transformationName>/foo'.
 */
export type FileMetadataGetter = (urlPath: string) => Promise<FileMetadata>;
